ARG ALPINE_VERSION=3.11
ARG PHP_VERSION=7.4

FROM alpine:${ALPINE_VERSION}

# Host dl.bintray.com not works.
# Change https://dl.bintray.com/php-alpine/key/php-alpine.rsa.pub
#   to https://packages.whatwedo.ch/php-alpine.rsa.pub.
# See more at https://github.com/codecasts/php-alpine/issues/131#issuecomment-823983749.
ADD https://packages.whatwedo.ch/php-alpine.rsa.pub /etc/apk/keys/php-alpine.rsa.pub

# make sure you can use HTTPS
RUN apk --update add ca-certificates
# Host dl.bintray.com not works.
# Change https://dl.bintray.com/php-alpine/{ALPINE_VERSION}/php-{PHP_VERSION}.
#   to https://packages.whatwedo.ch/php-alpine/{ALPINE_VERSION}/php-{PHP_VERSION}.
# See more at https://github.com/codecasts/php-alpine/issues/131#issuecomment-823983749.
RUN echo "https://packages.whatwedo.ch/php-alpine/v${ALPINE_VERSION}/php-${PHP_VERSION}" >> /etc/apk/repositories

# Install packages
RUN apk --no-cache add php php-fpm php-opcache php-openssl php-curl \
    nginx supervisor curl

# https://github.com/codecasts/php-alpine/issues/21
RUN test -L /usr/bin/php || ln -s /usr/bin/php7 /usr/bin/php

# Configure nginx
COPY config/nginx.conf /etc/nginx/nginx.conf

# Remove default server definition
RUN rm -f /etc/nginx/conf.d/default.conf

# Configure PHP-FPM
COPY config/fpm-pool.conf /etc/php7/php-fpm.d/www.conf
COPY config/php.ini /etc/php7/conf.d/custom.ini

# Configure supervisord
COPY config/supervisord.conf /etc/supervisor/conf.d/supervisord.conf

# Setup document root
RUN mkdir -p /var/www/html

# Make sure files/folders needed by the processes are accessable when they run under the nobody user
RUN chown -R nobody.nobody /var/www/html && \
  chown -R nobody.nobody /run && \
  chown -R nobody.nobody /var/lib/nginx && \
  chown -R nobody.nobody /var/log/nginx

# Switch to use a non-root user from here on
USER nobody

# Add application
WORKDIR /var/www/html
COPY --chown=nobody src/ /var/www/html/

# Expose the port nginx is reachable on
EXPOSE 8080

# Let supervisord start nginx & php-fpm
CMD ["/usr/bin/supervisord", "-c", "/etc/supervisor/conf.d/supervisord.conf"]

# Configure a healthcheck to validate that everything is up&running
HEALTHCHECK --timeout=10s CMD curl --silent --fail http://127.0.0.1:8080/fpm-ping
